{===========================================================================}
{==                                                                       ==}
{==                 SUPER CORECTOR DATAFILE CODER Version 4.0             ==}
{==                   Copyright (C) 1994-96 By The GodFather              ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,262144,655355} {16K Stack, 256K HeapMin, 640K HeapMax}

USES GUtils, GMemory;

CONST
  Version         = 'Version 4.0';
  CrackTerminator = #28;
  EncryptKey      = 234234234;

TYPE
  PArray = ^TArray;
  TArray = ARRAY[1..65000] OF Byte;

  TFileID = RECORD
           ID  : Word;
    LastUpdate : STRING[20];
          _EOF : Byte;
    TotalGames : Word;
   TotalCracks : Word;
   IndexOffset : Word;
     IndexSize : Word;
    DataOffset : Word;
      DataSize : Word;
  END;

  PFindReplace = ^TFindReplace;
  TFindReplace = OBJECT(TObject)
    Find       : PString;
    Replace    : PString;
    CONSTRUCTOR Init(NEW_Find,NEW_Replace:STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PFindReplaceCollection = ^TFindReplaceCollection;
  TFindReplaceCollection = OBJECT( TCollection )
  END;

  PCrack = ^TCrack;
  TCrack = OBJECT(TObject)
    C_Name  : PString;
    F_Name  : PString;
    FR_Data : PFindReplaceCollection;
    CONSTRUCTOR Init(NEW_C_Name, NEW_F_Name: STRING;
                     NEW_FindReplace       : PFindReplaceCollection );
    DESTRUCTOR Done; VIRTUAL;
  END;

  PCrackCollection = ^TCrackCollection;
  TCrackCollection = OBJECT( TCollection )
  END;

  PGame = ^TGame;
  TGame = OBJECT( TObject )
    Name : PString;
    Data : PCrackCollection;
    CONSTRUCTOR Init(NEW_Name:STRING; NEW_Data:PCrackCollection);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGamesCollection = ^TGamesCollection;
  TGamesCollection = OBJECT(TSortedCollection)
    FUNCTION KeyOf(Item:Pointer): Pointer; VIRTUAL;
    FUNCTION Compare(Key1, Key2:Pointer): Integer; VIRTUAL;
  END;

VAR
  LinesLength : PArray;
  TotalLines  : Word;
  GamesCount  : Word;
  CracksCount : Word;
  Database    : PGamesCollection;
  FileID      : TFileID;


FUNCTION Encrypt(St:STRING; Key:LongInt):STRING;
VAR I:Byte;
BEGIN
  RandSeed := Key;
  Encrypt[0] := St[0];
  FOR I := 1 TO Length(St) DO
    Encrypt[I] := Chr(Ord(St[I]) XOR (Random($80) OR $80));
END;


{--------------------------------------------------------}
CONSTRUCTOR TFindReplace.Init(NEW_Find,NEW_Replace:STRING);
VAR I,R: Byte; S1,S2: STRING[2];
BEGIN
  NEW_Find    := StripAll(NEW_Find   ,' ');
  NEW_Replace := StripAll(NEW_Replace,' ');
  IF Odd(Length(NEW_Find))    THEN NEW_Find[0]    := Chr(Ord(NEW_Find[0])-1);
  IF Odd(Length(NEW_Replace)) THEN NEW_Replace[0] := Chr(Ord(NEW_Replace[0])-1);
  R := 0;
  FOR I := 1 TO Length(NEW_Find) DO
  BEGIN
    S1 := Copy(NEW_Find   ,I,2);
    S2 := Copy(NEW_Replace,I,2);
    Inc(I); Inc(R);
    NEW_Find   [R] := Chr(HexToDec(S1));
    NEW_Replace[R] := Chr(HexToDec(S2));
  END;
  NEW_Find[0]    := Chr(Ord(NEW_Find[0])    DIV 2);
  NEW_Replace[0] := Chr(Ord(NEW_Replace[0]) DIV 2);
  Find           := NewStr(NEW_Find);
  Replace        := NewStr(NEW_Replace);
END;

DESTRUCTOR TFindReplace.Done;
BEGIN
  DisposeStr(Find);
  DisposeStr(Replace);
END;

CONSTRUCTOR TCrack.Init(NEW_C_Name, NEW_F_Name:STRING;
                        NEW_FindReplace       :PFindReplaceCollection);
BEGIN
  C_Name  := NewStr(NEW_C_Name);
  F_Name  := NewStr(NEW_F_Name);
  FR_Data := NEW_FindReplace;
END;

DESTRUCTOR TCrack.Done;
BEGIN
  DisposeStr(C_Name);
  DisposeStr(F_Name);
  Dispose(FR_Data,Done);
END;
{--------------------------------------------------------}

{--------------------------------------------------------}
CONSTRUCTOR TGame.Init( NEW_Name: STRING; NEW_Data: PCrackCollection );
BEGIN
  Name := NewStr(NEW_Name);
  Data := NEW_Data;
END;

DESTRUCTOR TGame.Done;
BEGIN
  DisposeStr(Name);
  Dispose(Data, Done);
END;

FUNCTION TGamesCollection.KeyOf(Item: Pointer): Pointer;
BEGIN
  KeyOf := @PGame(Item)^.Name;
END;

FUNCTION TGamesCollection.Compare(Key1, Key2: Pointer): Integer;
BEGIN
  IF PString( Key1^ )^ = PString( Key2^ )^
    THEN Compare := 0
    ELSE IF PString( Key1^ )^ < PString( Key2^ )^
      THEN Compare := -1
      ELSE Compare := 1;
END;
{--------------------------------------------------------}

PROCEDURE GetCracks;
VAR
  DataFile: Text;
  C_Data  : PCrackCollection;
  _GName  : STRING;
  Cnt     : Word;

  PROCEDURE GetCrk; NEAR;
  VAR TmpDTA: PCrackCollection;
      Tmp_FR: PFindReplaceCollection;
      _CName, _FName, _Find, _Replace: STRING;

     PROCEDURE ReadFR;
     VAR FR_DTA:PFindReplaceCollection; OneTime:Boolean;
     BEGIN
       New(FR_DTA,Init(1,1));
       REPEAT
         OneTime := True;
         Readln(DataFile, _Find);
         Readln(DataFile, _Replace);

         IF _Find[Length(_Find)] = '+' THEN
         BEGIN
           OneTime     := False;
           _Find[0]    := Chr(Ord(_Find[0])-1);
           _Replace[0] := Chr(Ord(_Replace[0])-1);
           _Find       := _Find    + '2B 2B';
           _Replace    := _Replace + '2B 2B';
         END;

         FR_DTA^.Insert(New(PFindReplace, Init(_Find,_Replace)));
       UNTIL OneTime;
       Tmp_FR := FR_DTA;
     END;

  BEGIN
    New(TmpDTA,Init(1,1));
    REPEAT
      Readln(DataFile, _CName); IF _CName = '-END-' THEN Break;
      Readln(DataFile, _FName); Inc(CracksCount);
      ReadFR;
      TmpDTA^.Insert(New(PCrack, Init(_CName,_FName,Tmp_FR)));
    UNTIL Eof(DataFile);
    C_Data := TmpDTA;
  END;

BEGIN
  Assign(DataFile, 'GSUPER.###');
  {$I-}
    Reset(DataFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Writeln('Can''t open GSUPER.###');
    Halt(2);
  END;
  Cnt := 1;
  Write('Reading      ');
  Database := New(PGamesCollection, Init(1, 1));
  Database^.Duplicates := True;
  REPEAT
    Inc(Cnt);
    IF Cnt = 10 THEN BEGIN Write(''); Cnt := 1; END;
    Readln(DataFile, _GName);
    GetCrk; Inc(GamesCount);
    Database^.Insert(New( PGame, Init(_GName,C_Data)));
  UNTIL Eof(DataFile);
  Close(DataFile);
  Write(#13);
END;

PROCEDURE CodeFile;
VAR
  F        : Text;
  AnEntry  : PGame;
  TheCrack : PCrack;
  TheFRDta : PFindReplace;
  I,R,G,Cnt: Word;

  F1,F2     : FILE;
  Buffer    : PArray;
  Readen    : Word;
  Written   : Word;
  _IndexSize: Word;
  _DataSize : Word;


  FUNCTION SSC(ST: STRING): STRING;
  VAR S1,S2: STRING;

    PROCEDURE Replace(WordNo:Byte; What:STRING; Ch:STRING);
    VAR S2: STRING;
    BEGIN
      IF WordNo = 1 THEN S2 := '' ELSE S2 := ExtractWords(1,1,St);
      IF AdjCase(Upper, ExtractWords(WordNo,1,St)) = AdjCase(Upper, What)
        THEN St := S2 + Ch + ExtractWords(WordNo+1,WordCnt(St),St);
    END;

  BEGIN
    St := Copy(St,2,Length(St)-1);
    Replace(1,'Make'     ,'! ');
    Replace(1,'Remove'   ,'@ ');
    Replace(1,'Stop'     ,'# ');
    Replace(1,'Unlimited','$ ');

    Replace(2,'BALLS'    ,'! ');
    Replace(2,'BOMBS'    ,'@ ');
    Replace(2,'BULLETS'  ,'# ');
    Replace(2,'ENERGY'   ,'$ ');
    Replace(2,'LIFE'     ,'% ');
    Replace(2,'LIFES'    ,'^ ');
    Replace(2,'MONEY'    ,'& ');
    Replace(2,'MISSLES'  ,'* ');
    Replace(2,'PASSWORDS','( ');
    Replace(2,'SHIELD'   ,') ');
    Replace(2,'TIME'     ,'_ ');
    Replace(2,'TIMER'    ,'+ ');
    SSC := ST;
  END;

  PROCEDURE AddToFile(St:STRING);
  VAR Temp:Byte;
  BEGIN
    Temp := Ord(St[0]);
    Inc(TotalLines);
    LinesLength^[TotalLines] := Temp XOR $A6;
    Write(F,Encrypt(St,EncryptKey));
  END;

BEGIN
  Assign(F,'DATA'); Rewrite(F);
  Write('Writing data ');
  Cnt := 1;
  TotalLines := 0;
  New(LinesLength);
  FOR R := 0 TO Database^.Count-1 DO
  BEGIN
    Inc(Cnt);
    IF Cnt = 10 THEN BEGIN Write(''); Cnt := 1; END;
    AnEntry := Database^.At(R);

    {Write data}
    AddToFile(GetStr(AnEntry^.Name));
    FOR I := 0 TO AnEntry^.Data^.Count - 1 DO
    BEGIN
      TheCrack := AnEntry^.Data^.At(I);
      AddToFile(SSC(TheCrack^.C_Name^));
      AddToFile(TheCrack^.F_Name^);
      FOR G := 0 TO TheCrack^.FR_Data^.Count - 1 DO
      BEGIN
        TheFRDta := TheCrack^.FR_Data^.At(G);
        AddToFile(TheFRDta^.Find^);
        AddToFile(TheFRDta^.Replace^);
      END;
    END;
    AddToFile(CrackTerminator);
  END;
  Close(F);
  Dispose(Database, Done);
  Writeln(' Done!');

  Write('Saving index. ');
  Assign(F2,'INDEX');
  Rewrite(F2,1);
  BlockWrite(F2,LinesLength^,TotalLines);
  Close(F2);
  Dispose(LinesLength);
  Writeln('Done!');

  Write('Creating GSUPER.DAT. ');
  _DataSize  := FSize('DATA');
  _IndexSize := FSize('INDEX');
  WITH FileID DO
  BEGIN
    ID            := $6353; {SC}
    LastUpdate    := CurrentDate+' '+CurrentTime+'h'+#26;
    LastUpdate[0] := Chr($1A);
    _EOF          := $1A;
    TotalGames    := GamesCount;
    TotalCracks   := CracksCount;
    IndexOffset   := SizeOf(FileID);
    IndexSize     := _IndexSize;
    DataOffset    := SizeOf(FileID)+_IndexSize;
    DataSize      := _DataSize;
  END;


  New(Buffer);
  Assign(F1,'GSUPER.DAT'); Rewrite(F1,1);
  BlockWrite(F1,FileID,SizeOf(FileID));         {Save ID}

  Assign(F2,'INDEX');  Reset(F2,1);
  BlockRead(F2,Buffer^,SizeOf(Buffer^),Readen); {Read INDEX}
  BlockWrite(F1,Buffer^,Readen,Written);        {Write INDEX}
  Close(F2);

  Assign(F2,'DATA');   Reset(F2,1);
  BlockRead(F2,Buffer^,SizeOf(Buffer^),Readen); {Read DATA}
  BlockWrite(F1,Buffer^,Readen,Written);        {Write DATA}
  Close(F2);

  Close(F1);
  Dispose(Buffer);
  Writeln('Done!');
  Writeln;
  DeleteFile('DATA');
  DeleteFile('INDEX');
END;

BEGIN
  Writeln;
  Writeln('SUPER CORECTOR DATAFILE CODER '+Version);
  Writeln('Copyright (C) 1994-96 By The GodFather');
  Writeln;
  Cursor(Off);
  GetCracks;
  CodeFile;
  Cursor(On);
END.
